import processing.pdf.*;
import java.util.Calendar;
import java.util.List;

class DropNode {

  float x;
  float y;
  float r;
  
  float v = 1;
  
  float red = 30 + random(60);
  float green = 0;
  float blue = 0;
  
  int life = 1;
  boolean falling = true;
  
  DropNode(float x, float y, float r) {
    this.x = x;
    this.y = y;
    this.r = r;
    
    if (this.r < 6) {
      falling = true;
    }
    
    blue = cos(x)*sin(y)*50;
  }
  
    void tick() {
      y += v;
      v *= 1.04;
  }
  
  void draw() {
    fill(red, green, blue);
    stroke(red, green, blue);
    ellipse(x, y, r*2, r*2);
  }
  
}

boolean savePDF = false;

int maxCount = 5000; //max count of the cirlces
int currentCount = 1;
List<DropNode> dropNodes = new ArrayList<DropNode>();



void setup() {
  size(1000, 1000);
  smooth();
  frameRate(1000);
  background(200,220,255);
  float pos = 0;
  for (int j = 0; j < 10; j++) {
    for (int i = 0; i < 1+(j/2.0); ++i) {
      float x = random(width);
      float y = pos;
      noStroke();
      float clr = random(170,220)-pos/15;
      fill(clr - 20);
      rect(x - 10, y, 100, height);
      fill(clr);
      rect(x, y, 100, height);
    }
    pos += height / 10;
  }
  
}


void draw() {
  if (savePDF) {
    savePDF = false;
    endRecord();
  }
}

void keyReleased() {
  if (key == 's' || key == 'S') saveFrame(timestamp()+"_##.png");
  if (key == 'p' || key == 'P') savePDF = true;
  
  if (key == ' ') setup();
}

// timestamp
String timestamp() {
  Calendar now = Calendar.getInstance();
  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", now);
}